gm convert

NAME

| convert - convert an image or sequence of images

Contents

Synopsis
Description
Examples
Options
Image Segmentation
Environment
Configuration Files
Authors
Copyright

Synopsis

| convert [ options ... ] input_file output_file

Description

| Convert converts an input file using one image format to an output file with a differing image format. In addition, various types of image processing can be performed on the converted image during the conversion process. Convert recognizes the image formats listed in GraphicsMagick(1).

Back to Contents

Examples

To make a thumbnail of a JPEG image, use:

        gm convert -size 120x120 cockatoo.jpg -resize 120x120 +profile "*" thumbnail.jpg

In this example, `'-size 120x120'` gives a hint to the JPEG decoder that the image is going to be downscaled to 120x120, allowing it to run faster by avoiding returning full-resolution images to GraphicsMagick for the subsequent resizing operation. The `'-resize 120x120'` specifies the desired dimensions of the output image. It will be scaled so its largest dimension is 120 pixels. The `'+profile "*"'` removes any ICM, EXIF, IPTC, or other profiles that might be present in the input and aren't needed in the thumbnail.

To convert a MIFF image of a cockatoo to a SUN raster image, use:

        gm convert cockatoo.miff sun:cockatoo.ras

To convert a multi-page PostScript document to individual FAX pages, use:

        gm convert -monochrome document.ps fax:page

To convert a TIFF image to a PostScript A4 page with the image in the lower left-hand corner, use:

        gm convert -page A4+0+0 image.tiff document.ps

To convert a raw Gray image with a 128 byte header to a portable graymap, use:

        gm convert -depth 8 -size 768x512+128 gray:raw image.pgm

In this example, "raw" is the input file. Its format is "gray" and it has the dimensions and number of header bytes specified by the -size option and the sample depth specified by the -depth option. The output file is "image.pgm". The suffix ".pgm" specifies its format.

To convert a Photo CD image to a TIFF image, use:

        gm convert -size 1536x1024 img0009.pcd image.tiff
        gm convert img0009.pcd[4] image.tiff

To create a visual image directory of all your JPEG images, use:

        gm convert 'vid:*.jpg' directory.miff

To annotate an image with blue text using font 12x24 at position (100,100), use:

        gm convert -font helvetica -fill blue -draw "text 100,100 Cockatoo"
                bird.jpg bird.miff

To tile a 640x480 image with a JPEG texture with bumps use:

        gm convert -size 640x480 tile:bumps.jpg tiled.png

To surround an icon with an ornamental border to use with Mosaic(1), use:

        gm convert -mattecolor "#697B8F" -frame 6x6 bird.jpg icon.png

To create a MNG animation from a DNA molecule sequence, use:

        gm convert -delay 20 dna.* dna.mng

Back to Contents

Options

Options are processed in command line order. Any option you specify on the command line remains in effect for the set of images that follows, until the set is terminated by the appearance of any option or -noop. Some options only affect the decoding of images and others only the encoding. The latter can appear after the final group of input images.

For a more detailed description of each option, see Options, above. GraphicsMagick(1).

| -adjoin

| join images into a single multi-image file

| -affine <matrix>

| drawing transform matrix

| -antialias

| remove pixel aliasing

| -append

| append a set of images

| -authenticate <string>

| decrypt image with this password

| -average

| average a set of images

| -background <color>

| the background color

| -blue-primary <x>,<y>

| blue chromaticity primary point

| -blur <radius>{x<sigma>}

| blur the image with a Gaussian operator

| -border <width>x<height>

| surround the image with a border of color

| -bordercolor <color>

| the border color

| -box <color>

| set the color of the annotation bounding box

| -channel <type>

| the type of channel

| -charcoal <factor>

| simulate a charcoal drawing

| -chop <width>x<height>{+-}<x>{+-}<y>{%}

| remove pixels from the interior of an image

| -clip

| apply the clipping path, if one is present

| -coalesce

| merge a sequence of images

| -colorize <value>

| colorize the image with the pen color

| -colors <value>

| preferred number of colors in the image

| -colorspace <value>

| the type of colorspace

| -comment <string>

| annotate an image with a comment

| -compose <operator>

| the type of image composition

| -compress <type>

| the type of image compression

| -contrast

| enhance or reduce the image contrast

| -convolve <kernel>

| convolve image with the specified convolution kernel

| -crop <width>x<height>{+-}<x>{+-}<y>{%}

| preferred size and location of the cropped image

| -cycle <amount>

| displace image colormap by amount

| -debug <events>

| enable debug printout

| -deconstruct

| break down an image sequence into constituent parts

| -define <key>{=<value>},...

| add coder/decoder specific options

| -delay <1/100ths of a second>

| display the next image after pausing

| -density <width>x<height>

| horizontal and vertical resolution in pixels of the image

| -depth <value>

| depth of the image

| -despeckle

| reduce the speckles within an image

| -display <host:display[.screen]>

| specifies the X server to contact

| -dispose <method>

| GIF disposal method

| -dither

| apply Floyd/Steinberg error diffusion to the image

| -draw <string>

| annotate an image with one or more graphic primitives

| -edge <radius>

| detect edges within an image

| -emboss <radius>

| emboss an image

| -encoding <type>

| specify the text encoding

| -endian <type>

| specify endianness (MSB or LSB) of output image

| -enhance

| apply a digital filter to enhance a noisy image

| -equalize

| perform histogram equalization to the image

| -fill <color>

| color to use when filling a graphic primitive

| -filter <type>

| use this type of filter when resizing an image

| -flatten

| flatten a sequence of images

| -flip

| create a "mirror image"

| -flop

| create a "mirror image"

| -font <name>

| use this font when annotating the image with text

| -frame <width>x<height>+<outer bevel width>+<inner bevel width>

| surround the image with an ornamental border

| -fuzz <distance>{%}

| colors within this distance are considered equal

| -gamma <value>

| level of gamma correction

| -Gaussian <radius>{x<sigma>}

| blur the image with a Gaussian operator

| -geometry <width>x<height>{+-}<x>{+-}<y>{%}{@} {!}{<}{>}

| preferred size and location of the Image window.

| -gravity <type>

| direction primitive gravitates to when annotating the image.

| -green-primary <x>,<y>

| green chromaticity primary point

| -help

| print usage instructions

| -implode <factor>

| implode image pixels about the center

| -intent <type>

| use this type of rendering intent when managing the image color

| -interlace <type>

| the type of interlacing scheme

| -label <name>

| assign a label to an image

| -lat <width>x<height>{+-}<offset>{%}

| perform local adaptive thresholding

| -level <black_point>{,<gamma>}{,<white_point>}{%}

| adjust the level of image contrast

| -limit <type> <value>

| Disk, File, Map, Memory, or Pixels resource limit

| -list <type>

| the type of list

| -log <string>

| Specify format for debug log

| -loop <iterations>

| add Netscape loop extension to your GIF animation

| -map <filename>

| choose a particular set of colors from this image

| -mask <filename>

| Specify a clipping mask

| -matte

| store matte channel if the image has one

| -mattecolor <color>

| specify the color to be used with the -frame option

| -median <radius>

| apply a median filter to the image

| -modulate brightness[,saturation[,hue]]

| vary the brightness, saturation, and hue of an image

| -monitor

| show progress indication

| -monochrome

| transform the image to black and white

| -morph <frames>

| morphs an image sequence

| -mosaic

| create a mosaic from an image or an image sequence

| -negate

| replace every pixel with its complementary color

| -noise <radius|type>

| add or reduce noise in an image

| -noop

| NOOP (no option)

| -normalize

| transform image to span the full range of color values

| -opaque <color>

| change this color to the pen color within the image

| -operator channel operator rvalue[%]

| apply a mathematical or bitwise operator to an image channel

| -ordered-dither <channeltype> <NxN>

| ordered dither the image

| -page <width>x<height>{+-}<x>{+-}<y>{%}{!}{<}{>}

| size and location of an image canvas

| -paint <radius>

| simulate an oil painting

| -pen <color>

| (This option has been replaced by the -fill option)

| -ping

| efficiently determine image characteristics

| -pointsize <value>

| pointsize of the PostScript, X11, or TrueType font

| -preview <type>

| image preview type

| -process <command>

| process a sequence of images using a process module

| -profile <filename>

| add ICM, IPTC, or generic profile to image

| -quality <value>

| JPEG/MIFF/PNG/TIFF compression level

| -raise <width>x<height>

| lighten or darken image edges

| -random-threshold <channeltype> <LOWxHIGH>

| random threshold the image

| -red-primary <x>,<y>

| red chromaticity primary point

| -region <width>x<height>{+-}<x>{+-}<y>

| apply options to a portion of the image

| -render

| render vector operations

| -resample <horizontal>x<vertical>

| Resample image to specified horizontal and vertical resolution

| -resize <width>x<height>{%}{@}{!}{<}{>}

| resize an image

| -roll {+-}<x>{+-}<y>

| roll an image vertically or horizontally

| -rotate <degrees>{<}{>}

| apply Paeth image rotation to the image

| -sample <geometry>

| scale image using pixel sampling

| -sampling-factor <horizontal_factor>x<vertical_factor>

| chroma subsampling factors

| -scale <geometry>

| scale the image.

| -scene <value>

| set scene number

| -set <attribute> <value>

| set an image attribut

| -segment <cluster threshold>x<smoothing threshold>

| segment an image

| -shade <azimuth>x<elevation>

| shade the image using a distant light source

| -sharpen <radius>{x<sigma>}

| sharpen the image

| -shave <width>x<height>{%}

| shave pixels from the image edges

| -shear <x degrees>x<y degrees>

| shear the image along the X or Y axis

| -size <width>x<height>{+offset}

| width and height of the image

| -solarize <factor>

| negate all pixels above the threshold level

| -spread <amount>

| displace image pixels by a random amount

| -stroke <color>

| color to use when stroking a graphic primitive

| -strokewidth <value>

| set the stroke width

| -swirl <degrees>

| swirl image pixels about the center

| -texture <filename>

| name of texture to tile onto the image background

| -threshold <value>{%}

| threshold the image

| -tile <filename>

| tile image when filling a graphic primitive

| -transform

| transform the image

| -transparent <color>

| make this color transparent within the image

| -treedepth <value>

| tree depth for the color reduction algorithm

| -trim

| trim an image

| -type <type>

| the image type

| -units <type>

| the units of image resolution

| -unsharp <radius>{x<sigma>}{+<amount>}{+<threshold>}

| sharpen the image with an unsharp mask operator

| -use-pixmap

| use the pixmap

| -verbose

| print detailed information about the image

| -version

| print GraphicsMagick version string

| -view <string>

| FlashPix viewing parameters

| -virtual-pixel <method>

| specify contents of "virtual pixels"

| -wave <amplitude>x<wavelength>

| alter an image along a sine wave

| -white-point <x>,<y>

| chromaticity white point

| -write <filename>

| write an intermediate image [convert, composite]

For a more detailed description of each option, see Options, above. GraphicsMagick(1).

Back to Contents

Segmentation

Use -segment to segment an image by analyzing the histograms of the color components and identifying units that are homogeneous with the fuzzy c-means technique. The scale-space filter analyzes the histograms of the three color components of the image and identifies a set of classes. The extents of each class is used to coarsely segment the image with thresholding. The color associated with each class is determined by the mean color of all pixels within the extents of a particular class. Finally, any unclassified pixels are assigned to the closest class with the fuzzy c-means technique.

The fuzzy c-Means algorithm can be summarized as follows:

- Build a histogram, one for each color component of the image.
- For each histogram, successively apply the scale-space filter and build an interval tree of zero crossings in the second derivative at each scale. Analyze this scale-space "fingerprint" to determine which peaks or valleys in the histogram are most predominant.
- The fingerprint defines intervals on the axis of the histogram. Each interval contains either a minima or a maxima in the original signal. If each color component lies within the maxima interval, that pixel is considered "classified" and is assigned an unique class number.
- Any pixel that fails to be classified in the above thresholding pass is classified using the fuzzy c-Means technique. It is assigned to one of the classes discovered in the histogram analysis phase.

The fuzzy c-Means technique attempts to cluster a pixel by finding the local minima of the generalized within group sum of squared error objective function. A pixel is assigned to the closest class of which the fuzzy membership has a maximum value.

For additional information see:

> Young Won Lim, Sang Uk Lee, ``On The Color Image Segmentation Algorithm Based on the Thresholding and the Fuzzy c-Means Techniques'', Pattern Recognition, Volume 23, Number 9, pages 935-952, 1990.

Back to Contents

Environment

| COLUMNS

| Output screen width. Used when formatting text for the screen. Many Unix systems keep this shell variable up to date, but it may need to be explicitly exported in order for GraphicsMagick to see it.

| DISPLAY

| X11 display ID (host, display number, and screen in the form hostname:display.screen).

| HOME

| Location of user's home directory. GraphicsMagick searches for configuration files in $HOME/.magick if the directory exists. See MAGICK_CODER_MODULE_PATH, MAGICK_CONFIGURE_PATH, and MAGICK_FILTER_MODULE_PATH if more flexibility is needed.

| MAGICK_CODER_MODULE_PATH

Search path to use when searching for image format coder modules. This path allows the user to arbitrarily extend the image formats supported by GraphicsMagick by adding loadable modules to an arbitrary location rather than copying them into the GraphicsMagick installation directory. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.

| MAGICK_CONFIGURE_PATH

| Search path to use when searching for configuration (.mgk) files. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.

| MAGICK_DEBUG

| Debug options (see -debug for details)

| MAGICK_FILTER_MODULE_PATH

Search path to use when searching for filter process modules (invoked via -process). This path allows the user to arbitrarily extend GraphicsMagick's image processing functionality by adding loadable modules to an arbitrary location rather than copying them into the GraphicsMagick installation directory. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.

| MAGICK_HOME

| Path to top of GraphicsMagick installation directory. Only observed by "uninstalled" builds of GraphicsMagick which do not have their location hard-coded or set by an installer.

| MAGICK_MMAP_READ

If MAGICK_MMAP_READ is set to TRUE, GraphicsMagick will attempt to memory-map the input file for reading. This usually substantially improves read performance if the file has recently been read. However, testing shows that performance may be reduced for files accessed for the first time via a network since some operating systems failed to do read-ahead over network mounts for memory mapped files.

| MAGICK_MMAP_WRITE

| If MAGICK_MMAP_WRITE is set to TRUE, GraphicsMagick will attempt to memory-map the output file for writing. This is an experimental feature (which is currently broken). Write performance is usually somewhat worse when using this approach rather than the default one.

| MAGICK_IOBUF_SIZE

The amount of I/O buffering (in bytes) to use when reading and writing encoded files. The default is 16384, which is observed to work well for many cases. The best value for a local filesystem is usually the the native filesystem block size (e.g. 4096, 8192, or even 131,072 for ZFS) in order to minimize the number of physical disk I/O operations. I/O performance to files accessed over a network may benefit significantly by tuning this option. Larger values are not necessarily better (they may be slower!), and there is rarely any benefit from using values larger than 32768. Use convert's -verbose option in order to evaluate read and write rates in pixels per second while keeping in mind that the operating system will try to cache files in RAM.

| MAGICK_LIMIT_DISK

| Maximum amount of disk space allowed for use by the pixel cache.

| MAGICK_LIMIT_FILES

| Maximum number of open files.

| MAGICK_LIMIT_MAP

| Maximum size of a memory map.

| MAGICK_LIMIT_MEMORY

| Maximum amount of memory to allocate from the heap.

| MAGICK_TMPDIR

| Path to directory where GraphicsMagick should write temporary files. The default is to use the system default, or the location set by TMPDIR.

| TMPDIR

| For POSIX-compatible systems (Unix-compatible), the path to the directory where all applications should write temporary files. Overridden by MAGICK_TMPDIR if it is set.

| TMP or TEMP

| For Microsoft Windows, the path to the directory where applications should write temporary files. Overridden by MAGICK_TMPDIR if it is set.

Back to Contents

Configuration Files

GraphicsMagick uses a number of XML format configuration files:

| colors.mgk

| colors configuration file

      <?xml version="1.0"?>
      <colormap>
        <color name="AliceBlue" red="240" green="248" blue="255"
               compliance="SVG, X11, XPM" />
      </colormap>

| delegates.mgk

| delegates configuration file

| log.mgk

| logging configuration file

      <?xml version="1.0"?>
      <magicklog>
        <log events="None" />
        <log output="stdout" />
        <log filename="Magick-%d.log" />
        <log generations="3" />
        <log limit="2000" />
        <log format="%t %r %u %p %m/%f/%l/%d:\n  %e"  />
      </magicklog>

| magic.mgk

| file header magic test configuration file

      <?xml version="1.0"?>
      <magicmap>
        <magic name="AVI" offset="0" target="RIFF" />
      </magicmap>

| modules.mgk

| loadable modules configuration file

      <?xml version="1.0"?>
      <modulemap>
        <module magick="8BIM" name="META" />
      </modulemap>

| type.mgk

| master type (fonts) configuration file

      <?xml version="1.0"?>
      <typemap>
        <include file="type-windows.mgk" />
        <type
          name="AvantGarde-Book"
          fullname="AvantGarde Book"
          family="AvantGarde"
          foundry="URW"
          weight="400"
          style="normal"
          stretch="normal"
          format="type1"
          metrics="/usr/local/share/ghostscript/fonts/a010013l.afm"
          glyphs="/usr/local/share/ghostscript/fonts/a010013l.pfb"
        />
      </typemap>

Back to Contents

Authors

| John Cristy, Bob Friesenhahn, Glenn Randers-Pehrson, William Radcliff, Leonard Rosenthol.

Back to Contents

Copyright

Copyright (C) 2002 - 2010 GraphicsMagick Group, an organization dedicated to making software imaging solutions freely available.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files ("GraphicsMagick"), to deal in GraphicsMagick without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of GraphicsMagick, and to permit persons to whom GraphicsMagick is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of GraphicsMagick.

The software is provided "as is", without warranty of any kind, express or implied, including but not limited to the warranties of merchantability, fitness for a particular purpose and noninfringement. In no event shall GraphicsMagick Group be liable for any claim, damages or other liability, whether in an action of contract, tort or otherwise, arising from, out of or in connection with GraphicsMagick or the use or other dealings in GraphicsMagick.

Except as contained in this notice, the name of the GraphicsMagick Group shall not be used in advertising or otherwise to promote the sale, use or other dealings in GraphicsMagick without prior written authorization from the GraphicsMagick Group.

Additional copyrights and licenses apply to this software. You should have received a copy of Copyright.txt with this package, which describes additional copyrights and licenses which apply to this software; otherwise see http://www.graphicsmagick.org/www/Copyright.html.

Back to Contents

[Home] [Utilities Index]

Copyright © GraphicsMagick Group 2002-2010